package com.key.vibekeyboard.Adapter;

import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.bumptech.glide.Glide;
import com.bumptech.glide.load.resource.bitmap.CenterCrop;
import com.bumptech.glide.load.resource.bitmap.RoundedCorners;
import com.bumptech.glide.request.RequestOptions;
import com.key.vibekeyboard.Activity.DownloadActivity;
import com.key.vibekeyboard.R;
import com.key.vibekeyboard.Room.WallpaperInfo;

import java.util.ArrayList;
import java.util.List;

public class CategoryRecyclerViewAdapter extends RecyclerView.Adapter<CategoryRecyclerViewAdapter.CategoryRecyclerViewHolder> {

    private Context context;
    private List<WallpaperInfo> list;

    public CategoryRecyclerViewAdapter(Context context, List<WallpaperInfo> list) {

        this.context = context;
        this.list = list;
    }

    @NonNull
    @Override
    public CategoryRecyclerViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.home_recycler_item, parent, false);
        return new CategoryRecyclerViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull CategoryRecyclerViewHolder holder, int position) {

        WallpaperInfo wallpaperInfo = list.get(position);
        Log.d("WallpaperInfo", "WallpaperInfo: " + wallpaperInfo);

        List<WallpaperInfo> limitedList = list.subList(0, Math.min(20, list.size()));

        if (wallpaperInfo != null) {
            holder.imageView.setOnClickListener(new View.OnClickListener() {
                @Override
                public void onClick(View v) {
                    Intent intent = new Intent(context, DownloadActivity.class);
                    intent.putExtra("wallpaperInfo", wallpaperInfo); // wallpaperInfo 已经实现了 Parcelable
                    intent.putParcelableArrayListExtra("list", new ArrayList<>(limitedList)); // list 中的 WallpaperInfo 对象实现了 Parcelable
                    context.startActivity(intent);
                }
            });

        } else {
            Log.e("WallpaperInfo", "WallpaperInfo is null at position: " + position);
        }

// 应用圆角变换
        RequestOptions options = new RequestOptions()
                .placeholder(R.mipmap.splash)
                .error(R.mipmap.splash)
                .transform(new CenterCrop())
                .transform(new RoundedCorners(16)); // 设置圆角度数

        Glide.with(context)
                .load(wallpaperInfo.getPreview())
                .apply(options)
                .into(holder.imageView);
    }

    @Override
    public int getItemCount() {
        return list.size();
    }

    public static class CategoryRecyclerViewHolder extends RecyclerView.ViewHolder {

        private ImageView imageView;
        public CategoryRecyclerViewHolder(View view) {
            super(view);
            imageView = view.findViewById(R.id.home_recycler_image);
        }
    }

}
